using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace KidzPad_SDG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private int	oldX, oldY, oldX2, oldY2;
		private int downX, downY;
		private Color penColor, penColor2;
		private Sdgt.SdgManager sdgManager1;
		private KidzPad_SDG.PenControl penControl1;
		private KidzPad_SDG.PenControl penControl2;
		private KidzPad_SDG.PenControl penControl3;
		private KidzPad_SDG.PenControl penControl4;
		private KidzPad_SDG.ButtonControl buttonControl1;
		private KidzPad_SDG.PenControl penControl5;
		private KidzPad_SDG.PenControl penControl6;
		private KidzPad_SDG.PenControl penControl7;
		private KidzPad_SDG.PenControl penControl8;
		private KidzPad_SDG.PenControl penControl9;
		private KidzPad_SDG.PenControl penControl10;
		private bool bothMode;
		private KidzPad_SDG.PenControl[] customPens = new PenControl[6];
		private Color[] customColors = new Color[6];
		private int customCounter;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			oldX = -1;
			oldY = -1;
			oldX2 = -1;
			oldY2 = -1;
			downX = -1;
			downY = -1;
			penColor = Color.Black;
			penColor2 = Color.Blue;
			bothMode = false;
			customCounter = 0;

			customPens[0] = penControl5;
			customPens[1] = penControl6;
			customPens[2] = penControl7;
			customPens[3] = penControl8;
			customPens[4] = penControl9;
			customPens[5] = penControl10;

			//set pen control 1
			ColorPen(penControl1, Color.FromArgb(0,255,0));

			//set pen control 2
			ColorPen(penControl2, Color.FromArgb(255,0,0));

			//set pen control 3
			ColorPen(penControl3, Color.FromArgb(0,0,255));

			//sep pen control 4
			ColorPen(penControl4, Color.FromArgb(255,255,0));

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.sdgManager1 = new Sdgt.SdgManager(this.components);
			this.penControl1 = new KidzPad_SDG.PenControl();
			this.penControl2 = new KidzPad_SDG.PenControl();
			this.penControl3 = new KidzPad_SDG.PenControl();
			this.penControl4 = new KidzPad_SDG.PenControl();
			this.buttonControl1 = new KidzPad_SDG.ButtonControl();
			this.penControl5 = new KidzPad_SDG.PenControl();
			this.penControl6 = new KidzPad_SDG.PenControl();
			this.penControl7 = new KidzPad_SDG.PenControl();
			this.penControl8 = new KidzPad_SDG.PenControl();
			this.penControl9 = new KidzPad_SDG.PenControl();
			this.penControl10 = new KidzPad_SDG.PenControl();
			this.SuspendLayout();
			// 
			// sdgManager1
			// 
			this.sdgManager1.EmulateSystemMouseMode = Sdgt.EmulateSystemMouseModes.Park;
			this.sdgManager1.Keyboards = null;
			this.sdgManager1.Mice = null;
			this.sdgManager1.MouseToFollow = 0;
			this.sdgManager1.ParkSystemMouseLocation = new System.Drawing.Point(350, 350);
			this.sdgManager1.RelativeTo = this;
			this.sdgManager1.MouseMove += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseMove);
			this.sdgManager1.MouseUp += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseUp);
			this.sdgManager1.MouseDown += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseDown);
			// 
			// penControl1
			// 
			this.penControl1.CausesValidation = false;
			this.penControl1.Location = new System.Drawing.Point(864, 568);
			this.penControl1.Name = "penControl1";
			this.penControl1.Size = new System.Drawing.Size(96, 120);
			this.penControl1.TabIndex = 0;
			this.penControl1.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl1_SdgMouseDown);
			// 
			// penControl2
			// 
			this.penControl2.CausesValidation = false;
			this.penControl2.Location = new System.Drawing.Point(768, 568);
			this.penControl2.Name = "penControl2";
			this.penControl2.Size = new System.Drawing.Size(96, 120);
			this.penControl2.TabIndex = 1;
			this.penControl2.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl2_SdgMouseDown);
			// 
			// penControl3
			// 
			this.penControl3.CausesValidation = false;
			this.penControl3.Location = new System.Drawing.Point(672, 568);
			this.penControl3.Name = "penControl3";
			this.penControl3.Size = new System.Drawing.Size(96, 120);
			this.penControl3.TabIndex = 2;
			this.penControl3.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl3_SdgMouseDown);
			// 
			// penControl4
			// 
			this.penControl4.CausesValidation = false;
			this.penControl4.Location = new System.Drawing.Point(576, 568);
			this.penControl4.Name = "penControl4";
			this.penControl4.Size = new System.Drawing.Size(96, 120);
			this.penControl4.TabIndex = 3;
			this.penControl4.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl4_SdgMouseDown);
			// 
			// buttonControl1
			// 
			this.buttonControl1.CausesValidation = false;
			this.buttonControl1.Location = new System.Drawing.Point(32, 648);
			this.buttonControl1.Name = "buttonControl1";
			this.buttonControl1.Size = new System.Drawing.Size(88, 40);
			this.buttonControl1.TabIndex = 4;
			this.buttonControl1.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.buttonControl1_SdgMouseDown);
			this.buttonControl1.SdgMouseUp += new Sdgt.SdgMouseEventHandler(this.buttonControl1_SdgMouseUp);
			// 
			// penControl5
			// 
			this.penControl5.CausesValidation = false;
			this.penControl5.Location = new System.Drawing.Point(8, 8);
			this.penControl5.Name = "penControl5";
			this.penControl5.Size = new System.Drawing.Size(80, 96);
			this.penControl5.TabIndex = 5;
			this.penControl5.Visible = false;
			this.penControl5.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl5_SdgMouseDown);
			// 
			// penControl6
			// 
			this.penControl6.CausesValidation = false;
			this.penControl6.Location = new System.Drawing.Point(8, 104);
			this.penControl6.Name = "penControl6";
			this.penControl6.Size = new System.Drawing.Size(80, 96);
			this.penControl6.TabIndex = 6;
			this.penControl6.Visible = false;
			this.penControl6.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl6_SdgMouseDown);
			// 
			// penControl7
			// 
			this.penControl7.CausesValidation = false;
			this.penControl7.Location = new System.Drawing.Point(8, 200);
			this.penControl7.Name = "penControl7";
			this.penControl7.Size = new System.Drawing.Size(80, 96);
			this.penControl7.TabIndex = 7;
			this.penControl7.Visible = false;
			this.penControl7.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl7_SdgMouseDown);
			// 
			// penControl8
			// 
			this.penControl8.CausesValidation = false;
			this.penControl8.Location = new System.Drawing.Point(8, 296);
			this.penControl8.Name = "penControl8";
			this.penControl8.Size = new System.Drawing.Size(80, 96);
			this.penControl8.TabIndex = 8;
			this.penControl8.Visible = false;
			this.penControl8.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl8_SdgMouseDown);
			// 
			// penControl9
			// 
			this.penControl9.CausesValidation = false;
			this.penControl9.Location = new System.Drawing.Point(8, 392);
			this.penControl9.Name = "penControl9";
			this.penControl9.Size = new System.Drawing.Size(80, 96);
			this.penControl9.TabIndex = 9;
			this.penControl9.Visible = false;
			this.penControl9.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl9_SdgMouseDown);
			// 
			// penControl10
			// 
			this.penControl10.CausesValidation = false;
			this.penControl10.Location = new System.Drawing.Point(8, 488);
			this.penControl10.Name = "penControl10";
			this.penControl10.Size = new System.Drawing.Size(80, 96);
			this.penControl10.TabIndex = 10;
			this.penControl10.Visible = false;
			this.penControl10.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.penControl10_SdgMouseDown);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(976, 709);
			this.Controls.Add(this.penControl10);
			this.Controls.Add(this.penControl9);
			this.Controls.Add(this.penControl8);
			this.Controls.Add(this.penControl7);
			this.Controls.Add(this.penControl6);
			this.Controls.Add(this.penControl5);
			this.Controls.Add(this.buttonControl1);
			this.Controls.Add(this.penControl4);
			this.Controls.Add(this.penControl3);
			this.Controls.Add(this.penControl2);
			this.Controls.Add(this.penControl1);
			this.Name = "Form1";
			this.Text = "Drawing Area";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void sdgManager1_MouseMove(object sender, Sdgt.SdgMouseEventArgs e)
		{
//			if(sdgManager1.Mice[0].Cursor.Equals(Cursors.Default))
//			{
//				return;
//			}

			Graphics g = this.CreateGraphics();
			Pen penC = new Pen(penColor,3);

			if (e.ID > 0)
			{

				penC.Color = penColor2;
				
				if ((e.Button & MouseButtons.Left) > 0)
				{
					if((oldX == -1) && (oldY == -1))
					{
						g.DrawLine(penC, new Point(e.X, e.Y), new Point(e.X+1, e.Y+1));
					}
					else
					{
						if(bothMode)
						{
							penC.Color = Color.FromArgb((penColor.R+penColor2.R)/2,(penColor.G+penColor2.G)/2,(penColor.B+penColor2.B)/2);
							g.DrawLine(penC, new Point(oldX2, oldY2), new Point(e.X, e.Y));
						}
						else
							g.DrawLine(penC, new Point(oldX, oldY), new Point(e.X, e.Y));
					}
				}

				oldX = e.X;
				oldY = e.Y;
			}
			else
			{
				if ((e.Button & MouseButtons.Left) > 0)
				{
					if((oldX2 == -1) && (oldY2 == -1))
					{
						g.DrawLine(penC, new Point(e.X, e.Y), new Point(e.X+1, e.Y+1));
					}
					else
					{
						if(bothMode)
						{
							penC.Color = Color.FromArgb((penColor.R+penColor2.R)/2,(penColor.G+penColor2.G)/2,(penColor.B+penColor2.B)/2);
							g.DrawLine(penC, new Point(oldX, oldY), new Point(e.X, e.Y));
						}
						else
							g.DrawLine(penC, new Point(oldX2, oldY2), new Point(e.X, e.Y));
					}
				}

				oldX2 = e.X;
				oldY2 = e.Y;
			}
		}


		private void penControl1_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl1,Color.FromArgb(0,255,0),e.ID);
		}

		private void penControl2_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl2,Color.FromArgb(255,0,0),e.ID);
		}

		private void penControl3_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl3,Color.FromArgb(0,0,255),e.ID);
		}

		private void penControl4_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl4,Color.FromArgb(255,255,0),e.ID);
		}

		private void sdgManager1_MouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			if((downX == -1)&&(downY == -1))
			{
				downX = e.X;
				downY = e.Y;
				return;
			}

			if((e.X<=downX+5)&&(e.X>=downX-5)&&(e.Y<=downY+5)&&(e.Y>=downY-5))
			{
				bothMode = true;
			}

		}

		private void sdgManager1_MouseUp(object sender, Sdgt.SdgMouseEventArgs e)
		{
			downX = -1;
			downY = -1;

			Color newColor = Color.FromArgb((penColor.R+penColor2.R)/2,(penColor.G+penColor2.G)/2,(penColor.B+penColor2.B)/2);
			if(bothMode)
			{
				for(int i=0; i<6; i++)
				{
					if(customColors[i] == newColor)
					{
						bothMode = false;
						return;
					}
				}

				if(customCounter>6)
					customCounter = 0;
				customColors[customCounter] = newColor;
				customPens[customCounter].Show();

				ColorPen(customPens[customCounter], customColors[customCounter]);
				bothMode = false;
				customCounter++;
			}

		}

		private void buttonControl1_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			buttonControl1.pressed = true;
			buttonControl1.Invalidate();
			this.Invalidate();
		}

		private void buttonControl1_SdgMouseUp(object sender, Sdgt.SdgMouseEventArgs e)
		{
			buttonControl1.pressed = false;
			buttonControl1.Invalidate();
		}

		private void penControl5_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl5,customColors[0],e.ID);
		}

		private void penControl6_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl6,customColors[1],e.ID);
		}

		private void penControl7_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl7,customColors[2],e.ID);
		}

		private void penControl8_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl8,customColors[3],e.ID);
		}

		private void penControl9_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl9,customColors[4],e.ID);
		}

		private void penControl10_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			SelectPen(penControl10,customColors[5],e.ID);
		}

		public void ColorPen(PenControl pen, Color color)
		{
			Image crayonImage = pen.getPictureBox().Image;
			Bitmap crayonBitmap = new Bitmap(crayonImage);
			for(int y=0; y<crayonBitmap.Height; y++)
			{
				for(int x=0; x<crayonBitmap.Width; x++)
				{
					if(crayonBitmap.GetPixel(x,y) == Color.FromArgb(255,255,0))
					{
						crayonBitmap.SetPixel(x,y,color);
					}
				}
			}
			pen.getPictureBox().Image = crayonBitmap;
		}

		public void SelectPen(PenControl pen, Color color, int mouseID)
		{
			if(!pen.getIsSelected() && (sdgManager1.Mice[mouseID].Cursor.Equals(Cursors.Default)))
			{
				pen.setIsSelected(true);
				Image crayonImage = pen.getPictureBox().Image;
				pen.getPictureBox().Hide();
				Bitmap crayonBitmap = new Bitmap(crayonImage);
				crayonBitmap.MakeTransparent(Color.FromArgb(253,253,253));
				IntPtr ptr = crayonBitmap.GetHicon();
				Cursor c = new Cursor(ptr);
				if(mouseID>0)
				{
					sdgManager1.Mice[1].Cursor = c;
					penColor2 = color;
					pen.setCursor(1);
				}
				else
				{
					sdgManager1.Mice[0].Cursor = c;
					penColor = color;
					pen.setCursor(0);
				}
			}
			else
			{
				if(pen.getCursor() != mouseID)
				{
					return;
				}
				pen.setIsSelected(false);
				pen.setCursor(-1);
				if(mouseID>0)
					sdgManager1.Mice[1].Cursor = Cursors.Default;
				else
					sdgManager1.Mice[0].Cursor = Cursors.Default;
				pen.getPictureBox().Show();
			}
		}

	}
}
